diff --git a/src/building/building.h b/src/building/building.h
index f620cf90c..0117f55d8 100644
--- a/src/building/building.h
+++ b/src/building/building.h
@@ -65,7 +65,7 @@ typedef struct {
         struct {
             short queued_docker_id;
             unsigned char num_ships;
-            char orientation;
+            signed char orientation;
             short docker_ids[3];
             short trade_ship_id;
         } dock;
@@ -133,8 +133,8 @@ typedef struct {
     unsigned char is_adjacent_to_water;
     unsigned char storage_id;
     union {
-        char house_happiness;
-        char native_anger;
+        signed char house_happiness;
+        signed char native_anger;
     } sentiment;
     unsigned char show_on_problem_overlay;
 } building;
diff --git a/src/city/sentiment.c b/src/city/sentiment.c
index cd6e70bb5..9f3b88ee6 100644
--- a/src/city/sentiment.c
+++ b/src/city/sentiment.c
@@ -31,8 +31,7 @@ void city_sentiment_change_happiness(int amount)
     for (int i = 1; i < MAX_BUILDINGS; i++) {
         building *b = building_get(i);
         if (b->state == BUILDING_STATE_IN_USE && b->house_size) {
-            b->sentiment.house_happiness += amount;
-            b->sentiment.house_happiness = calc_bound(b->sentiment.house_happiness, 0, 100);
+            b->sentiment.house_happiness = calc_bound(b->sentiment.house_happiness + amount, 0, 100);
         }
     }
 }
